Require Import Morphisms.

Class PropHolds (P : Prop) := prop_holds: P.

Instance: Proper (iff ==> iff) PropHolds.
Proof. now repeat intro. Qed.

Ltac solve_propholds :=
  match goal with
  | [ |- PropHolds (?P) ] => apply _
  | [ |- ?P ] => change (PropHolds P); apply _
  end.

Hint Extern 0 (PropHolds _) => assumption : typeclass_instances.

Require Import Ch12_parallel.

Section Essai.

Context `{MT:Tarski_2D_euclidean}.
Context `{EqDec:EqDecidability Tpoint}.
Context `{InterDec:InterDecidability Tpoint Col}.

Lemma par_col_par_bis : forall {A B C D D' : Tpoint},
  `{PropHolds (Par A B C D)} ->
  C <> D' ->
  `{PropHolds (Col C D D')} ->
  Par A B C D'.
Proof.
intros.
unfold PropHolds in *.
apply par_col_par with D;assumption.
Qed.

Hint Resolve par_reflexivity par_strict_irreflexivity
 not_par_strict_id par_strict_symmetry  par_id par_symmetry
 par_left_comm par_right_comm : par.

Ltac Par := eauto with par.

Instance par_sym_r (A B C D:Tpoint) {H: PropHolds (Par A B C D)} : (PropHolds (Par A B D C)).
unfold PropHolds in *.
Par.
Qed.

About par_col_par_bis.

Hint Extern 0 (PropHolds _) => Par : typeclass_instances.


Typeclasses eauto := debug.

Lemma essai : forall A B C D D' : Tpoint,
  C <> D' ->
  (Par A B D C) ->
  (Col C D D') ->
   Par A B C D'.
Proof.
intros.
eapply (par_col_par_bis ).

auto with typeclass_instances.
auto with typeclass_instances.
auto with typeclass_instances.
Qed.







