
Notation "A => B" := (forall (_:A), B) (at level 99, no associativity, y at level 200) :  tptp_fol_scope.

Notation "A <=> B" := (iff A B) (at level 95, no associativity): tptp_fol_scope.

Notation "A & B" := (and A B) (at level 80, right associativity): tptp_fol_scope.

Notation "A | B" := (or A B) (at level 85, right associativity): tptp_fol_scope.

Notation "A != B" := (~ eq A B)  (at level 95, no associativity): tptp_fol_scope.

(*
Notation " '!' '[' x ']' : P" := (forall (x :_), P)  (at level 90, no associativity): tptp_fol_scope.
*)

Notation " '?' '[' x ']' : p" := (ex (fun x => p))
  (at level 200,  no associativity)
  : tptp_fol_scope.

(*
Notation " '?' '[' x .. y ']' : p" := (ex (fun x => .. (ex (fun y => p)) ..))
  (at level 200, x binder, y binder, right associativity)
  : tptp_fol_scope.
*)

Open Scope tptp_fol_scope.

Require Import Ch12_parallel.

Section Tptp.

Context `{MT:Tarski_2D_euclidean}.
Context `{EqDec:EqDecidability Tpoint}.
Context `{InterDec:InterDecidability Tpoint Col}.


Notation "bet( A , B , C )" := (Bet A B C) : tptp_fol_scope.
Notation "bet_4( A , B , C , D )" := (Bet_4 A B C D) : tptp_fol_scope.
Notation "cong( A , B , C , D )" := (Cong A B C D) : tptp_fol_scope.
Notation "cong_3( A , B , C , D , E , F )" := (Cong_3 A B C D E F) : tptp_fol_scope.
Notation "per( A , B , C )" := (Per A B C) : tptp_fol_scope.
Notation "col( A , B , C )" := (Col A B C) : tptp_fol_scope.
Notation "is_midpoint( A , B , C )" := (is_midpoint A B C) : tptp_fol_scope.
Notation "perp( A , B , C , D )" := (Perp A B C D) : tptp_fol_scope.
Notation "perp_in( A , B , C , D , E )" := (Perp_in A B C D E) : tptp_fol_scope.
Notation "one_side( A , B , C , D )" := (one_side A B C D) : tptp_fol_scope.
Notation "obtuse( A , B , C )" := (obtuse A B C) : tptp_fol_scope.
Notation "acute( A , B , C )" := (acute A B C) : tptp_fol_scope.
Notation "lt( A , B , C , D )" := (lt A B C D) : tptp_fol_scope.
Notation "le( A , B , C , D )" := (le A B C D) : tptp_fol_scope.
Notation "gt( A , B , C , D )" := (gt A B C D) : tptp_fol_scope.
Notation "ge( A , B , C , D )" := (ge A B C D) : tptp_fol_scope.
Notation "Distincts( A , B , C )" := (Distincts A B C) : tptp_fol_scope.
Notation "lta( A , B , C , D , E , F )" := (lta A B C D E F) : tptp_fol_scope.
Notation "Par( A , B , C , D )" := (Par A B C D) : tptp_fol_scope.
Notation "ofsc( A , B , C , D , E , F , G , H )" := (OFSC A B C D E F G H) : tptp_fol_scope.
Notation "fsc( A , B , C , D , E , F , G , H )" := (FSC A B C D E F G H) : tptp_fol_scope.
Notation "ifsc( A , B , C , D , E , F , G , H )" := (IFSC A B C D E F G H) : tptp_fol_scope.
Notation "conga( A , B , C , D , E , F )" := (Conga A B C D E F) : tptp_fol_scope.
Notation "lea( A , B , C , D , E , F )" := (lea A B C D E F) : tptp_fol_scope.
Notation "lta( A , B , C , D , E , F )" := (lta A B C D E F) : tptp_fol_scope.
Notation "gta( A , B , C , D , E , F )" := (gta A B C D E F) : tptp_fol_scope.
Notation "gea( A , B , C , D , E , F )" := (gea A B C D E F) : tptp_fol_scope.
Notation "par( A , B , C , D )" := (Par A B C D) : tptp_fol_scope.
Notation "par_strict( A , B , C , D )" := (Par_strict A B C D) : tptp_fol_scope.
Notation "coplanar( A , B , C , D )" := (coplanar A B C D) : tptp_fol_scope.
Notation "out( A , B , C )" := (out A B C) : tptp_fol_scope.
Notation "two_sides( A , B , C , D )" := (two_sides A B C D) : tptp_fol_scope.
Notation "is_symmetric( A , B , C )" := (is_symmetric A B C) : tptp_fol_scope.
Notation "one_side( A , B , C , D )" := (one_side A B C D) : tptp_fol_scope.
Notation "is_image( A , B , C , D )" := (is_image A B C D) : tptp_fol_scope.
Notation "is_image_spec_in( A , B , C , D , E )" := (is_image_spec_in A B C D E) : tptp_fol_scope.
Notation "inangle( A , B , C , D )" := (InAngle A B C D) : tptp_fol_scope.
Notation "inter( A , B , C , D , E )" := (inter A B C D E) : tptp_fol_scope.
Notation "is_image_spec( A , B , C , D )" := (is_image_spec A B C D) : tptp_fol_scope.
Notation "is_image_spec_in_gen( A , B , C , D , E )" := (is_image_spec_in_gen A B C D E) : tptp_fol_scope.

(*
End Tptp.
*)
Check cong_reflexivity.
Check cong_symmetry.
Check cong_transitivity.
Check cong_left_commutativity.
Check cong_right_commutativity.
Check cong_trivial_identity.
Check cong_reverse_identity.
Check cong_commutativity.
Check cong_dec_eq_dec.
Check five_segments_with_def.
Check cong_diff.
Check cong_diff_2.
Check cong_diff_3.
Check cong_diff_4.
Check cong_3_sym.
Check cong_3_swap.
Check cong_3_swap_2.
Check cong3_transitivity.
Check l2_11.
Check construction_unicity.
Check bet_col.
Check between_trivial.
Check bet_dec_eq_dec.
Check between_symmetry.
Check Bet_cases.
Check between_trivial2.
Check between_egality.
Check between_inner_transitivity.
Check between_exchange3.
Check outer_transitivity_between2.
Check between_exchange2.
Check outer_transitivity_between.
Check between_exchange4.
Check l_3_9_4.
Check l3_17.
Check two_distinct_points.
Check point_construction_different.
Check another_point.
Check l2_11_b.
Check cong_dec_eq_dec_b.
Check bet_dec_eq_dec_b.
Check l4_2.
Check l4_3.
Check l4_5.
Check l4_6.
Check cong3_bet_eq.
Check col_permutation_1.
Check col_permutation_2.
Check col_permutation_3.
Check col_permutation_4.
Check col_permutation_5.
Check not_col_permutation_1.
Check not_col_permutation_2.
Check not_col_permutation_3.
Check not_col_permutation_4.
Check not_col_permutation_5.
Check Col_cases.
Check col_trivial_1.
Check col_trivial_2.
Check col_trivial_3.
Check l4_13.
Check l4_14.
Check l4_16.
Check l4_17.
Check l4_18.
Check l4_19.
Check not_col_distincts.
Check l5_1.
Check l5_2.
Check l5_3.
Check l5_5_1.
Check l5_5_2.
Check l5_6.
Check le_reflexivity.
Check le_transitivity.
Check between_cong.
Check cong3_symmetry.
Check between_cong_2.
Check between_cong_3.
Check le_anti_symmetry.
Check segment_construction_2.
Check Cong_dec.
Check Bet_dec.
Check Col_dec.
Check le_trivial.
Check le_cases.
Check le_zero.
Check bet_cong_eq.
Check fourth_point.
Check third_point.
Check out_dec.
Check out_diff1.
Check out_diff2.
Check out_distinct.
Check out_col.
Check l6_2.
Check l6_3_1.
Check l6_3_2.
Check l6_4_1.
Check l6_4_2.
Check out_trivial.
Check l6_6.
Check l6_7.
Check bet_out_out_bet.
Check out2_bet_out.
Check l6_11_unicity.
Check l6_11_existence.
Check l6_13_1.
Check l6_13_2.
Check l6_16_1.
Check col_transitivity_1.
Check col_transitivity_2.
Check l6_21.
Check l6_25.
Check t2_8.
Check col3.
Check is_midpoint_dec.
Check is_midpoint_id.
Check is_midpoint_id_2.
Check l7_2.
Check l7_3.
Check l7_3_2.
Check symmetric_point_construction.
Check symmetric_point_unicity.
Check l7_9.
Check diff_bet.
Check l7_13.
Check l7_15.
Check l7_16.
Check symmetry_preserves_midpoint.
Check l7_17.
Check l7_20.
Check cong_col_mid.
Check l7_21.
Check l7_22_aux.
Check l7_22.
Check bet_col1.
Check bet_col2.
Check l7_25.
Check midpoint_distinct_1.
Check midpoint_distinct_2.
Check midpoint_distinct_3.
Check midpoint_def.
Check midpoint_bet.
Check midpoint_col.
Check midpoint_cong.
Check midpoint_not_midpoint.
Check swap_diff.
Check Per_dec.
Check l8_2.
Check Per_cases.
Check l8_3.
Check l8_4.
Check l8_5.
Check l8_6.
Check l8_7.
Check l8_8.
Check l8_9.
Check l8_10.
Check col_col_per_per.
Check Perp_in_dec.
Check perp_distinct.
Check l8_12.
Check l4_3_1.
Check per_col.
Check l8_13_2.
Check perBAB.
Check l8_14_1.
Check l8_14_2_1a.
Check perp_in_distinct.
Check l8_14_2_1b.
Check l8_14_2_1b_bis.
Check l8_14_2_2.
Check l8_14_3.
Check l8_15_1.
Check l8_15_2.
Check perp_in_per.
Check perp_sym.
Check perp_col0.
Check l8_16_1.
Check per_perp_in.
Check per_perp.
Check perp_left_comm.
Check perp_right_comm.
Check perp_comm.
Check perp_in_sym.
Check perp_in_left_comm.
Check perp_in_right_comm.
Check perp_in_comm.
Check Perp_cases.
Check Perp_in_cases.
Check l8_16_2.
Check l8_18_unicity.
Check distinct.
Check l8_20_1.
Check l8_20_2.
Check perp_col1.
Check l8_18_existence.
Check l8_21_aux.
Check l8_21.
Check perp_in_col.
Check perp_perp_in.
Check perp_per_1.
Check perp_per_2.
Check perp_col.
Check perp_col2.
Check perp_not_eq_1.
Check perp_not_eq_2.
Check le_bet.
Check bet_cong3.
Check diff_per_diff.
Check per_not_colp.
Check per_not_col.
Check per_cong.
Check perp_cong.
Check midpoint_existence_aux.
Check midpoint_existence.
Check perp_in_id.
Check l8_22.
Check l8_22_bis.
Check perp_in_perp.
Check perp_proj.
Check l8_24.
Check perp_not_col2.
Check ex_col2.
Check perp_in_col_perp_in.
Check l9_2.
Check invert_two_sides.
Check inter_unicity.
Check colx.
Check l9_3.
Check sym_sym.
Check distinct.
Check diff_col_ex.
Check diff_bet_ex3.
Check diff_col_ex3.
Check mid_preserves_col.
Check per_mid_per.
Check perp_in_perp.
Check sym_preserve_diff.
Check perp_col2.
Check l9_4_1_aux.
Check per_col_eq.
Check l9_4_1.
Check mid_two_sides.
Check col_preserves_two_sides.
Check out_out_two_sides.
Check l9_4_2_aux.
Check l9_4_2.
Check l9_5.
Check outer_pasch.
Check invert_one_side.
Check l9_8_1.
Check not_two_sides_id.
Check l9_8_2.
Check l9_9.
Check l9_9_bis.
Check one_side_chara.
Check l9_10.
Check one_side_reflexivity.
Check one_side_symmetry.
Check one_side_transitivity.
Check col_eq.
Check l9_17.
Check l9_18.
Check l9_19.
Check ex_sym.
Check is_image_is_image_spec.
Check ex_sym1.
Check l10_2_unicity.
Check l10_2_existence_spec.
Check l10_2_existence.
Check l10_4_spec.
Check l10_4.
Check l10_5.
Check l10_6_unicity.
Check l10_6_existence_spec.
Check l10_6_existence.
Check l10_7.
Check l10_8.
Check is_image_col_cong.
Check is_image_spec_col_cong.
Check perp_not_col.
Check image_id.
Check osym_not_col.
Check cong_cong_half.
Check coplanar_perm_1.
Check coplanar_perm_2.
Check coplanar_perm_3.
Check coplanar_perm_4.
Check coplanar_perm_5.
Check coplanar_perm_6.
Check coplanar_perm_7.
Check coplanar_perm_8.
Check coplanar_perm_9.
Check coplanar_perm_10.
Check coplanar_perm_11.
Check per_per_col.
Check per_per_perp.
Check midpoint_preserves_image.
Check image_in_is_image_spec.
Check image_in_gen_is_image.
Check image_image_in.
Check image_in_col.
Check image_in_col0.
Check l10_10_spec.
Check l10_10.
Check is_image_spec_rev.
Check is_image_rev.
Check per_double_cong.
Check midpoint_preserves_per.
Check image_preserves_bet.
Check image_gen_preserves_bet.
Check image_preserves_midpoint.
Check image_preserves_per.
Check col_per_perp.
Check image_col.
Check is_image_spec_triv.
Check is_image_spec_dec.
Check l10_12.
Check l10_14.
Check l10_15.
Check l10_16.
Check not_col_exists.
Check perp_exists.
Check l11_3.
Check cong_preserves_bet.
Check l11_aux.
Check l11_3_bis.
Check out_cong_cong.
Check l11_4_1.
Check l11_4_2.
Check conga_refl.
Check conga_sym.
Check out_conga.
Check bet_out.
Check cong3_conga.
Check cong3_conga2.
Check diff_out.
Check conga_diff1.
Check conga_diff2.
Check conga_trans.
Check conga_pseudo_refl.
Check conga_trivial_1.
Check l11_10.
Check l11_13.
Check conga_right_comm.
Check conga_left_comm.
Check conga_comm.
Check conga_line.
Check l11_14.
Check l11_16.
Check l11_17.
Check l11_18_1.
Check l11_18_2.
Check not_bet_out.
Check cong3_preserves_out.
Check l11_21_a.
Check l11_21_b.
Check col_two_sides.
Check col_one_side.
Check l11_22_aux.
Check per_cong_mid.
Check cong2_conga_cong.
Check not_two_sides.
Check segment_construction_3.
Check ex_per_cong.
Check not_out_bet.
Check angle_construction_1.
Check angle_construction_2.
Check l11_15.
Check l11_19.
Check l11_22_bet.
Check not_bet_and_out.
Check out_to_bet.
Check l11_22a.
Check l11_22b.
Check l11_22.
Check l11_24.
Check out_in_angle.
Check col_in_angle.
Check in_angle_two_sides.
Check in_angle_out.
Check col_in_angle_out.
Check l11_25_aux.
Check l11_25.
Check segment_construction_0.
Check angle_construction_3.
Check l11_28.
Check bet_conga_bet.
Check out_in_angle_out.
Check two_sides_not_col.
Check one_side_not_col.
Check out_out_one_side.
Check in_angle_one_side.
Check or_bet_out.
Check in_angle_trivial_1.
Check in_angle_trivial_2.
Check col_out2_col .
Check col_conga_col.
Check ncol_conga_ncol.
Check l11_29_a.
Check in_angle_line.
Check l11_29_b.
Check bet_in_angle_bet.
Check lea_line.
Check bet2_out_out.
Check eq_conga_out.
Check out_conga_out.
Check out_one_side.
Check conga_ex_cong3.
Check conga_preserves_in_angle.
Check l11_30.
Check l11_31_1.
Check l11_31_2.
Check lea_refl.
Check in_angle_trans.
Check lea_trans.
Check out2_out_1.
Check out2_out_2.
Check out_bet_out_1.
Check out_bet_out_2.
Check in_angle_asym.
Check lea_asym.
Check two_sides_in_angle.
Check col_one_side_out.
Check col_two_sides_bet.
Check col_perp_perp_col.
Check out_two_sides_two_sides.
Check not_two_sides_one_side_aux.
Check not_two_sides_one_side.
Check l9_31.
Check in_angle_reverse.
Check l11_36.
Check l11_41_aux.
Check l11_41.
Check not_conga.
Check not_conga_sym.
Check not_and_lta.
Check conga_preserves_lta.
Check conga_preserves_gta.
Check lta_trans.
Check gta_trans.
Check lea_left_comm.
Check lea_right_comm.
Check lea_comm.
Check lta_left_comm.
Check lta_right_comm.
Check lta_comm.
Check l11_43_aux.
Check obtuse_sym.
Check acute_sym.
Check l11_43.
Check acute_lea_acute.
Check obtuse_gea_obtuse.
Check lea_acute_obtuse.
Check l11_44_1_a.
Check l11_44_2_a.
Check not_lta_and_cong.
Check not_gta_and_cong.
Check not_lta_and_gta.
Check conga_sym_equiv.
Check Conga_dec.
Check or_lt_cong_gt.
Check lta_not_conga.
Check l11_44_1_b.
Check l11_44_2_b.
Check l11_44_1.
Check l11_44_2.
Check between_symmetric.
Check le_left_comm.
Check le_right_comm.
Check le_comm.
Check ge_left_comm.
Check ge_right_comm.
Check ge_comm.
Check lt_right_comm.
Check lt_left_comm.
Check lt_comm.
Check gt_left_comm.
Check gt_right_comm.
Check gt_comm.
Check acute_distinct.
Check lta_diff.
Check l5_12_a.
Check l5_12_b.
Check l11_46.
Check l11_47.
Check l11_49.
Check l11_50_1 .
Check l11_50_2 .
Check l11_51.
Check conga_distinct.
Check bet_le_eq.
Check l11_52.
Check l11_53.
Check par_reflexivity.
Check par_strict_irreflexivity.
Check not_par_strict_id.
Check par_strict_symmetry.
Check par_id.
Check par_strict_not_col_1.
Check par_strict_not_col_2.
Check par_strict_not_col_3.
Check par_strict_not_col_4.
Check par_id_1.
Check par_id_2.
Check par_id_3.
Check par_id_4.
Check par_id_5.
Check par_symmetry.
Check par_left_comm.
Check par_right_comm.
Check par_comm.
Check par_strict_left_comm.
Check par_strict_right_comm.
Check par_strict_comm.
Check Par_cases.
Check Par_strict_cases.
Check l12_6.
Check perp_perp_col.
Check Perp_dec.
Check perp_perp_col_col.
Check l12_9.
Check parallel_existence.
Check par_col_par.
Check parallel_existence_spec.
Check par_not_col.
Check not_strict_par1.
Check not_strict_par2.
Check not_strict_par.
Check not_par_not_col.
Check not_par_inter_unicity.
Check inter_unicity_not_par.
Check col_not_col_not_par.
Check par_distincts.
Check par_not_col_strict.
Check all_one_side_par_strict.
Check par_col_par_2.
Check par_col2_par.
Check par_strict_col_par_strict.
Check par_strict_col2_par_strict.
Check line_dec.
Check par_distinct.
Check inter_trivial.
Check inter_sym.
Check inter_left_comm.
Check inter_right_comm.
Check inter_comm.
Check other_point_exists.
Check l12_17.
Check l12_18_a.
Check l12_18_b.
Check l12_18_c.
Check l12_18_d.
Check l12_18.
Check par_two_sides_two_sides.
Check out_one_side_1.
Check midpoint_preserves_out.
Check l12_21_b.
Check l6_7_1.
Check l12_22_aux.
Check l12_22_b.
Check par_strict_par.
Check par_strict_distinct.
Check col_par.
Check perp_not_par.
Check ltac_something_eq.
Check ltac_something_hide.
Check ltac_something_show.
End Tptp.
