Require Import quadrilaterals.

Section Square.

Context `{MT:Tarski_2D_euclidean}.

Definition Square A B C D := Rectangle A B C D /\ Cong A B B C.

Lemma Square_Rectangle :
 forall A B C D,
 Square A B C D -> Rectangle A B C D.
Proof.
unfold Square;tauto.
Qed.


Lemma Square_Rhombus : 
 forall A B C D,
 Square A B C D -> Rhombus A B C D.
Proof.
unfold Square, Rhombus, Rectangle.
tauto.
Qed.


Class Rect (A B C D: Tpoint) :=
 { Rect_Plg: Plg A B C D;
   Rect_Cong: Cong A C B D}.


Class Rhomb (A B C D: Tpoint) :=
 { Rhomb_Plg: Plg A B C D;
   Rhomb_Cong: Cong A B B C }.



Class Carre (A B C D: Tpoint) :=
 { Carre_Rect :> Rect A B C D;
   Carre_Rhomb :> Rhomb A B C D
  }.




Lemma test: forall A B C D, 
(forall A B C D,
 Rhomb A B C D -> Cong A B C D) ->

Carre A B C D -> Cong A B C D.
intros.
apply H.
apply H0.
Qed.


End Square.
