
Notation "A => B" := (forall (_:A), B) (at level 99, no associativity, y at level 200) :  tptp_fol_scope.

Notation "A <=> B" := (iff A B) (at level 95, no associativity): tptp_fol_scope.

Notation "A & B" := (and A B) (at level 80, right associativity): tptp_fol_scope.

Notation "A | B" := (or A B) (at level 85, right associativity): tptp_fol_scope.

Notation "A != B" := (~ eq A B)  (at level 95, no associativity): tptp_fol_scope.

(*
Notation " '!' '[' x ']' : P" := (forall (x :_), P)  (at level 90, no associativity): tptp_fol_scope.
*)

Notation " '?' '[' x ']' : p" := (ex (fun x => p))
  (at level 200,  no associativity)
  : tptp_fol_scope.

(*
Notation " '?' '[' x .. y ']' : p" := (ex (fun x => .. (ex (fun y => p)) ..))
  (at level 200, x binder, y binder, right associativity)
  : tptp_fol_scope.
*)

Open Scope tptp_fol_scope.

Require Import Ch12_parallel.

Section Tptp.

Context `{MT:Tarski_2D_euclidean}.
Context `{EqDec:EqDecidability Tpoint}.
Context `{InterDec:InterDecidability Tpoint Col}.


Notation "bet( A , B , C )" := (Bet A B C) : tptp_fol_scope.
Notation "bet_4( A , B , C , D )" := (Bet_4 A B C D) : tptp_fol_scope.
Notation "cong( A , B , C , D )" := (Cong A B C D) : tptp_fol_scope.
Notation "cong_3( A , B , C , D , E , F )" := (Cong_3 A B C D E F) : tptp_fol_scope.
Notation "per( A , B , C )" := (Per A B C) : tptp_fol_scope.
Notation "col( A , B , C )" := (Col A B C) : tptp_fol_scope.
Notation "is_midpoint( A , B , C )" := (is_midpoint A B C) : tptp_fol_scope.
Notation "perp( A , B , C , D )" := (Perp A B C D) : tptp_fol_scope.
Notation "perp_in( A , B , C , D , E )" := (Perp_in A B C D E) : tptp_fol_scope.
Notation "one_side( A , B , C , D )" := (one_side A B C D) : tptp_fol_scope.
Notation "obtuse( A , B , C )" := (obtuse A B C) : tptp_fol_scope.
Notation "acute( A , B , C )" := (acute A B C) : tptp_fol_scope.
Notation "lt( A , B , C , D )" := (lt A B C D) : tptp_fol_scope.
Notation "le( A , B , C , D )" := (le A B C D) : tptp_fol_scope.
Notation "gt( A , B , C , D )" := (gt A B C D) : tptp_fol_scope.
Notation "ge( A , B , C , D )" := (ge A B C D) : tptp_fol_scope.
Notation "Distincts( A , B , C )" := (Distincts A B C) : tptp_fol_scope.
Notation "lta( A , B , C , D , E , F )" := (lta A B C D E F) : tptp_fol_scope.
Notation "Par( A , B , C , D )" := (Par A B C D) : tptp_fol_scope.
Notation "ofsc( A , B , C , D , E , F , G , H )" := (OFSC A B C D E F G H) : tptp_fol_scope.
Notation "fsc( A , B , C , D , E , F , G , H )" := (FSC A B C D E F G H) : tptp_fol_scope.
Notation "ifsc( A , B , C , D , E , F , G , H )" := (IFSC A B C D E F G H) : tptp_fol_scope.
Notation "conga( A , B , C , D , E , F )" := (Conga A B C D E F) : tptp_fol_scope.
Notation "lea( A , B , C , D , E , F )" := (lea A B C D E F) : tptp_fol_scope.
Notation "lta( A , B , C , D , E , F )" := (lta A B C D E F) : tptp_fol_scope.
Notation "gta( A , B , C , D , E , F )" := (gta A B C D E F) : tptp_fol_scope.
Notation "gea( A , B , C , D , E , F )" := (gea A B C D E F) : tptp_fol_scope.
Notation "par( A , B , C , D )" := (Par A B C D) : tptp_fol_scope.
Notation "par_strict( A , B , C , D )" := (Par_strict A B C D) : tptp_fol_scope.
Notation "coplanar( A , B , C , D )" := (coplanar A B C D) : tptp_fol_scope.
Notation "out( A , B , C )" := (out A B C) : tptp_fol_scope.
Notation "two_sides( A , B , C , D )" := (two_sides A B C D) : tptp_fol_scope.
Notation "is_symmetric( A , B , C )" := (is_symmetric A B C) : tptp_fol_scope.
Notation "one_side( A , B , C , D )" := (one_side A B C D) : tptp_fol_scope.
Notation "is_image( A , B , C , D )" := (is_image A B C D) : tptp_fol_scope.
Notation "is_image_spec_in( A , B , C , D , E )" := (is_image_spec_in A B C D E) : tptp_fol_scope.
Notation "inangle( A , B , C , D )" := (InAngle A B C D) : tptp_fol_scope.
Notation "inter( A , B , C , D , E )" := (inter A B C D E) : tptp_fol_scope.
Notation "is_image_spec( A , B , C , D )" := (is_image_spec A B C D) : tptp_fol_scope.
Notation "is_image_spec_in_gen( A , B , C , D , E )" := (is_image_spec_in_gen A B C D E) : tptp_fol_scope.

(*
End Tptp.
*)
